## $Id: export.py 13155 2015-07-07 20:53:37Z henrik $
##
## Copyright (C) 2012 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""Exporters for applicant-related stuff.
"""
import grok
from waeup.kofa.applicants.interfaces import IApplicantBaseData
from waeup.kofa.applicants.export import ApplicantExporter
from kofacustom.nigeria.applicants.interfaces import (
    INigeriaUGApplicant, INigeriaPGApplicant)

class NigeriaApplicantExporter(ApplicantExporter):
    """Exporter for Nigeria Applicants.
    """

    # In contrast to ApplicantExporter we export all fields
    # and attributes of the interfaces.
    fields = tuple(sorted(set(
        INigeriaUGApplicant.names() +
        INigeriaPGApplicant.names() +
        IApplicantBaseData.names()
        )))

    def mangle_value(self, value, name, context=None):
        if name == 'jamb_subjects' and value:
            value = value.replace('\n', '++')
        if '_result' in name and value:
            value = [eval(entry.to_string()) for entry in value]
        return super(
            NigeriaApplicantExporter, self).mangle_value(
            value, name, context=context)
